/***************************************************************************
                          OSTest.java  -  the base clas for all tests
                             -------------------
    begin                : Thu May 16 14:12:39 CDT 2002
    copyright            : (C) 2002 by Fred Trotter
    email                : ftrotter@verisign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
import java.net.*;

abstract class JOSTest 
{
	public String OSFamily;
	public String OSMajorVersion;
	public String OSMinorVersion;
	public String OSOther;
	public String OSArch;

// My constructor list. 

	public JOSTest(){
		OSFamily = "Unknown";
		OSMajorVersion="Unknown";
		OSMinorVersion="Unknown";
		OSOther="Unknown";
		OSArch="Unknown"; 

	} 

	public JOSTest(String SetFamily)
	{
		OSFamily=SetFamily;
		OSMajorVersion="Unknown";
		OSMinorVersion="Unknown";
		OSArch="Unknown"; 
	}

	public JOSTest(String SetFamily, String SetMajorVersion)
	{
		OSFamily=SetFamily;
		OSMajorVersion=SetMajorVersion;
		OSMinorVersion="Unknown";
		OSArch="Unknown"; 
	}
	
	public JOSTest(String SetFamily, String SetMajorVersion, String SetMinorVersion)
	{
		OSFamily=SetFamily;
		OSMajorVersion=SetMajorVersion;
		OSMinorVersion=SetMinorVersion;
		OSArch="Unknown"; 
	}

	public JOSTest(String SetFamily, String SetMajorVersion, String SetMinorVersion, String SetArch)
	{
		OSFamily=SetFamily;
		OSMajorVersion=SetMajorVersion;
		OSMinorVersion=SetMinorVersion;
		OSArch=SetArch; 
	}


	static public boolean compatible(JOSTest First, JOSTest Second)
	{
	
		// If the families are different and neither of the are unknown
		// then the two Operating Systems cannot be equal
		// So we reject "Solaris" vs "Windows"
		// but we accept "Solaris" vs "Unknown"
		if((First.OSFamily.compareTo(Second.OSFamily)!=0)&&
		((First.OSFamily.compareTo("Unknown")!=0)||
		(Second.OSFamily.compareTo("Unknown")!=0)))
		{
			return(false);
		}
		// the Same is true of the version number 
		if((First.OSMajorVersion.compareTo(Second.OSMajorVersion)!=0)&&
		((First.OSMajorVersion.compareTo("Unknown")!=0)||
		(Second.OSMajorVersion.compareTo("Unknown")!=0)))
		{
			return(false);
		}
		
		// We will not check for Minor Version number because of the large amount 
		// Of fluff here...

		// We will also not check for Arch... but there is a seperate function for that... 

		// Which means if it gets here then there is a possiblity that the two fingerprints
		// Could be equal
		return(true);

	}

	
	static public boolean archcompatible(JOSTest First, JOSTest Second)
	{
		
		if((First.OSArch.compareTo(Second.OSArch)!=0)&&
		((First.OSArch.compareTo("Unknown")!=0)||
		(Second.OSArch.compareTo("Unknown")!=0)))
		{
			return(false);
		}

		return(true);

	}

	static public boolean identical(JOSTest First,JOSTest Second)
	{

		// This more stringent test requires that everything be the same.
		// no  Unknowns will fly here!!
		if(First.OSFamily.compareTo(Second.OSFamily)!=0)
		{	return(false);	}

		if(First.OSMajorVersion.compareTo(Second.OSMajorVersion)!=0)
		{	return(false);  }

		return(true);
	}

	static public boolean archidentical(JOSTest First,JOSTest Second)
	{
		if(First.OSArch.compareTo(Second.OSArch)!=0)
		{   return(false); 	}

		return(true);


	}


	//Consider writing wrapper functions here to just take a single JOSTest and 
	// then comparing it to the "this" object



// My core abstract functions
	abstract void runtest(InetAddress target);






}
