#include <jni.h>
#include "JnmapTXOSTest.h"
#include "JnmapTXOSListen.h"
#include <stdio.h>
#include "libos.h"


JNIEXPORT void JNICALL Java_JnmapTXOSListen_Jnmap_1TXOSListen
  (JNIEnv *env, jobject thisobj){
// my JNI classes needed for movement between the OSes
	  // I wish that I could send another object as a argument and use that 
      jclass classofFillMeIn = (*env)->GetObjectClass(env,thisobj);
      jfieldID RespID;
      jfieldID DFID;
      jfieldID WID;
      jfieldID AckID;
      jfieldID flagsID;
      jfieldID OpsID;

      jint JResp;
      jint JDF;
      jshort JW;
      jint JAck;
      jint Jflags;
      jstring JOps;
       

	  u_long srciptosend;
      u_long dstiptosend;
      u_short srcprttosend;
      u_short dstprttosend;
      u_int seqtosend;
      u_short idtosend;
      libnet_t *toresolve;
 char errbuf[LIBNET_ERRBUF_SIZE];
      char *src_ip_string = "192.168.2.2";
      char *dst_ip_string = "192.168.2.3";
      NMAP_TX_results T1;
 
#ifdef STEPS
	printf("JOSimp Listen \tI am in JOSimp \n");
#endif

      
      toresolve = libnet_init(
            LIBNET_RAW4,                            /* injection type */
            NULL,                                   /* network interface */
            errbuf);                                /* errbuf */
 
    if (toresolve == NULL)
    {
        fprintf(stderr, "libnet_init() failed: %s", errbuf);
        exit(EXIT_FAILURE);
    }


      
                if (!(srciptosend = libnet_name2addr4(toresolve,src_ip_string , LIBNET_RESOLVE)))
                {
                    fprintf(stderr, "Bad source IP address: %s\n", optarg);
                    exit(1);
                }


                if (!(dstiptosend = libnet_name2addr4(toresolve,dst_ip_string, LIBNET_RESOLVE)))
                {
                    fprintf(stderr, "Bad destination IP address: %s\n", optarg);                    
                    exit(1);
                }
      
	srcprttosend=10000;
	dstprttosend=80;
	seqtosend=0;
	idtosend=0;

#ifdef STEPS
	printf("JOSimp Listen\tI have resolved the character based IP addresses \n");
#endif
	

	T1 = nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);
	
#ifdef STEPS
	printf("JOSimp Listen\t I have recieved the results of my test \n");
#endif


#ifdef STEPS 
	printf("JOSimp Listen\t I will begin placing my c structure into JNI types\n");
#endif

	

	
       JResp=T1.Resp;
       JDF=T1.DF;
       JW=T1.W;
       JAck=T1.Ack;
       Jflags = (int)T1.flags;
       JOps = (*env)->NewStringUTF(env,T1.Ops);
      printf("JOSimp Listen\t This is what is in the Ops section %c%c%c%c%c%c%c%c \n",T1.Ops[0],T1.Ops[1],T1.Ops[2],T1.Ops[3],T1.Ops[4],T1.Ops[5],T1.Ops[6],T1.Ops[7]);
	
#ifdef STEPS 
	printf("JOSimp Listen\t Now I will place the variables into the JVM \n");
	printf("JOSimp Listen\t ");
        printf("Resp...");
#endif

	
      RespID = (*env)->GetFieldID(env,classofFillMeIn,
		               "tempResp", "I");

      (*env)->SetIntField(env,thisobj,RespID,JResp);
#ifdef STEPS      
printf("DF...");
#endif      
      DFID = (*env)->GetFieldID(env,classofFillMeIn,
		               "tempDF", "I");
      (*env)->SetIntField(env,thisobj,DFID,JDF);
#ifdef STEPS
      printf("W...");      
#endif      
      WID = (*env)->GetFieldID(env,classofFillMeIn,
		               "tempW", "S");
      (*env)->SetShortField(env,thisobj,WID,JW);
#ifdef STEPS
      printf("Ack...");
#endif
      
      AckID = (*env)->GetFieldID(env,classofFillMeIn,
		               "tempAck", "I");
      (*env)->SetIntField(env,thisobj,AckID,JAck);

printf("flags...");
      
      flagsID = (*env)->GetFieldID(env,classofFillMeIn,
		               "tempflags", "C");
      (*env)->SetCharField(env,thisobj,flagsID,Jflags);
       
printf("Opts...");

      OpsID = (*env)->GetFieldID(env,classofFillMeIn,
		               "tempOps","Ljava/lang/String;");
      (*env)->SetObjectField(env,thisobj,OpsID,JOps);
       
printf("Done!\n");

      
  }

JNIEXPORT void JNICALL Java_JnmapTXOSTest_Jnmap_1TX
  (JNIEnv *env, jobject thisobj, 
   			jstring src_jstring, 
			jstring dst_jstring,
		       	jshort srcport, 
			jshort dstport, 
			jint seq,
		       	jint testnumber){
	  
      char *result;
      u_long srciptosend;
      u_long dstiptosend;
      u_short srcprttosend;
      u_short dstprttosend;
      u_int seqtosend;
      u_short idtosend;
      libnet_t *toresolve;
      char errbuf[LIBNET_ERRBUF_SIZE];
      const char *src_ip_string =  (*env)->GetStringUTFChars(env,src_jstring,0);
      const char *dst_ip_string =  (*env)->GetStringUTFChars(env,dst_jstring,0);

      
#ifdef STEPS
	printf("JOSimp TX\t I am inside T1 \n");
#endif

     srcprttosend=(unsigned short)srcport;
     dstprttosend=(unsigned short)dstport;
     seqtosend=(unsigned int)seq;
     idtosend=0;
    
      


	

    toresolve = libnet_init(
            LIBNET_RAW4,                            /* injection type */
            NULL,                                   /* network interface */
            errbuf);                                /* errbuf */
 
    if (toresolve == NULL)
    {
        fprintf(stderr, "libnet_init() failed: %s", errbuf);
        exit(EXIT_FAILURE);
    }


      
                if (!(srciptosend = libnet_name2addr4(toresolve,(u_char *) src_ip_string , LIBNET_RESOLVE)))
                {
                    fprintf(stderr, "Bad source IP address: %s\n", optarg);
                    exit(1);
                }


                if (!(dstiptosend = libnet_name2addr4(toresolve,(u_char *) dst_ip_string, LIBNET_RESOLVE)))
                {
                    fprintf(stderr, "Bad destination IP address: %s\n", optarg);                    
                    exit(1);
                }


	(*env)->ReleaseStringUTFChars(env,dst_jstring,dst_ip_string);		
	(*env)->ReleaseStringUTFChars(env,src_jstring,src_ip_string);		
         

	
#ifdef STEPS
	printf("JOSimp TX\tI have resolved the character based IP addresses \n");
#endif


	result=nmap_T1(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);
	
	

  }

