/*
 */

/***************************************************************************
                          T1main.c  - 
			  this program simply launches a single test and then proves that we 
			  can finger print with it.
                             -------------------
    begin                : Thu May 16 14:12:39 CDT 2002
    copyright            : (C) 2002 by Fred Trotter
    email                : ftrotter@verisign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "needed_libraries.h"
#include "nmap_T1.h"
#include "nmap_T2.h"
#include "nmap_T3.h"
#include "nmap_T4.h"
#include "nmap_T5.h"
#include "nmap_T6.h"
#include "nmap_T7.h"
#include "nmap_PU.h"
#include "nmap_listen_TX.h"
#include "queso_T1.h"
#include "queso_T2.h"
#include "queso_T3.h"
#include "queso_T4.h"
#include "queso_T5.h"
#include "queso_T6.h"
#include "queso_listen.h"
#include "x_ir.h"
#include "x_mr.h"
#include "x_time.h"
#include "x_udp.h"


int main(int argc, char **argv)
{
      char *result;
      u_long srciptosend;
      u_long dstiptosend;
      u_short srcprttosend;
      u_short dstprttosend;
      u_int seqtosend;
      u_short idtosend;
      libnet_t *toresolve;
      char errbuf[LIBNET_ERRBUF_SIZE];
      char *src_ip_string = "192.168.2.2";
      char *dst_ip_string = "192.168.2.3";
      NMAP_TX_results T1;
    toresolve = libnet_init(
            LIBNET_RAW4,                            /* injection type */
            NULL,                                   /* network interface */
            errbuf);                                /* errbuf */
 
    if (toresolve == NULL)
    {
        fprintf(stderr, "libnet_init() failed: %s", errbuf);
        exit(EXIT_FAILURE);
    }


      
                if (!(srciptosend = libnet_name2addr4(toresolve,src_ip_string , LIBNET_RESOLVE)))
                {
                    fprintf(stderr, "Bad source IP address: %s\n", optarg);
                    exit(1);
                }


                if (!(dstiptosend = libnet_name2addr4(toresolve,dst_ip_string, LIBNET_RESOLVE)))
                {
                    fprintf(stderr, "Bad destination IP address: %s\n", optarg);                    
                    exit(1);
                }
      
	srcprttosend=10000;
	dstprttosend=80;
	seqtosend=0;
	idtosend=0;

	
#ifdef STEPS
	printf("MAIN\tI have resolved the character based IP addresses \n");
#endif


	result=nmap_T1(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);
	
	T1 = nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);	

#ifdef STEPS
	printf("MAIN\t look! I am in main now... but I know \n");
	printf("MAIN\t that DF=%d \n",T1.DF);
	printf("MAIN\t that W=%d \n",T1.W);
	if (T1.Ack==0)
        {
		printf("MAIN\t that Ack = O \n");
	}else
	{
		if (T1.Ack==1)
		{
			printf("MAIN\t that Ack = S \n");
		}else
		{
			if (T1.Ack==2)
			{
				printf("MAIN\t that Ack = S++ \n");
			}
		}
	}
	printf("MAIN\t ");     	
        if (T1.flags & TH_BOGUS) printf("B");
	if (T1.flags & TH_URG) printf("U");
	if (T1.flags & TH_ACK) printf("A");
	if (T1.flags & TH_PUSH) printf("P");
	if (T1.flags & TH_RST) printf("R");
	if (T1.flags & TH_SYN) printf("S");
	if (T1.flags & TH_FIN) printf("F");
        printf("\n");		




#endif
	
	
	return 1;
}


