/*
 */

/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Thu May 16 14:12:39 CDT 2002
    copyright            : (C) 2002 by Fred Trotter
    email                : ftrotter@verisign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "needed_libraries.h"
#include "nmap_T1.h"
#include "nmap_T2.h"
#include "nmap_T3.h"
#include "nmap_T4.h"
#include "nmap_T5.h"
#include "nmap_T6.h"
#include "nmap_T7.h"
#include "nmap_listen.h"


int main(int argc, char **argv)
{
      char *result;
      u_long srciptosend;
      u_long dstiptosend;
      u_short srcprttosend;
      u_short dstprttosend;
      u_int seqtosend;
      libnet_t *toresolve;
      char errbuf[LIBNET_ERRBUF_SIZE];
      char *src_ip_string = "12.239.151.0";
      char *dst_ip_string = "www.synwear.com";
      
    toresolve = libnet_init(
            LIBNET_RAW4,                            /* injection type */
            NULL,                                   /* network interface */
            errbuf);                                /* errbuf */
 
    if (toresolve == NULL)
    {
        fprintf(stderr, "libnet_init() failed: %s", errbuf);
        exit(EXIT_FAILURE);
    }


      
                if (!(srciptosend = libnet_name2addr4(toresolve,src_ip_string , LIBNET_RESOLVE)))
                {
                    fprintf(stderr, "Bad source IP address: %s\n", optarg);
                    exit(1);
                }


                if (!(dstiptosend = libnet_name2addr4(toresolve,dst_ip_string, LIBNET_RESOLVE)))
                {
                    fprintf(stderr, "Bad destination IP address: %s\n", optarg);                    
                    exit(1);
                }
      
	srcprttosend=10000;
	dstprttosend=80;
	seqtosend=0x01010101;

	
#ifdef STEPS
	printf("MAIN\tI have resolved the character based IP addresses \n");
#endif
	
	result=nmap_T1(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);


	result=nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);
	
#ifdef STEPS
	printf("MAIN\tI have recieved the results of nmap_T1 \n");
#endif

#ifdef STEPS
	printf("MAIN\tI am about to start nmap_T2 \n");
#endif
	
	result=nmap_T2(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);

	result=nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);
#ifdef STEPS
	printf("MAIN\tI have recieved the results of nmap_T2 \n");
#endif
#ifdef STEPS
	printf("MAIN\tI am about to start nmap_T3 \n");
#endif
	
	result=nmap_T3(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);
	result=nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);

#ifdef STEPS
	printf("MAIN\tI have recieved the results of nmap_T3 \n");
#endif
#ifdef STEPS
	printf("MAIN\tI am about to start nmap_T4 \n");
#endif
	
	result=nmap_T4(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);
	result=nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);

#ifdef STEPS
	printf("MAIN\tI have recieved the results of nmap_T4 \n");
#endif


#ifdef STEPS
	printf("MAIN\tswitching to closed ports \n");
#endif

	dstprttosend=20000;
	
#ifdef STEPS
	printf("MAIN\tI am about to start nmap_T5 \n");
#endif
	
	result=nmap_T5(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);
	result=nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);

#ifdef STEPS
	printf("MAIN\tI have recieved the results of nmap_T1 \n");
#endif
#ifdef STEPS
	printf("MAIN\tI am about to start nmap_T6 \n");
#endif
	
	result=nmap_T6(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);
	result=nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);

#ifdef STEPS
	printf("MAIN\tI have recieved the results of nmap_T1 \n");
#endif
#ifdef STEPS
	printf("MAIN\tI am about to start nmap_T7 \n");
#endif
	
	result=nmap_T7(srciptosend,dstiptosend,srcprttosend,dstprttosend,seqtosend);
	result=nmap_listen(srciptosend,dstiptosend,srcprttosend,seqtosend);

#ifdef STEPS
	printf("MAIN\tI have recieved the results of nmap_T7 \n");
#endif
	
        libnet_destroy(toresolve);
	return EXIT_SUCCESS;
}



