


#if (HAVE_CONFIG_H)
#include "../include/config.h"
#endif
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// these are all the system calls that I wanted !!
#ifndef MY_INCLUDES
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/if_ether.h>
#include <pcap.h>
#include <libnet.h> // I use the beta version 1.1 make sure you do too!!
#include <time.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#define MY_INCLUDES 
#endif

// my macros, usually I can get away with using LIBNETS but not for say... the bogus tcp flag
#ifndef MY_CONSTANTS
#define TH_BOGUS 0x40
#define TH_YYY   0x80
/* Ethernet header */
struct sniff_ethernet {
        u_char  ether_dhost[ETHER_ADDR_LEN];    /* Destination host address */
        u_char  ether_shost[ETHER_ADDR_LEN];    /* Source host address */
        u_short ether_type;                     /* IP? ARP? RARP? etc */
};

/* IP header */
struct sniff_ip {
        #if BYTE_ORDER == LITTLE_ENDIAN
                u_int   ip_hl:4,        /* header length */
                        ip_v:4;         /* version */
        #if BYTE_ORDER == BIG_ENDIAN
                u_int   ip_v:4,         /* version */
                        ip_hl:4;        /* header length */
        #endif
        #endif /* not _IP_VHL */
        u_char  ip_tos;                 /* type of service */
        u_short ip_len;                 /* total length */
        u_short ip_id;                  /* identification */
        u_short ip_off;                 /* fragment offset field */
        #define IP_RF 0x8000            /* reserved fragment flag */
        #define IP_DF 0x4000            /* dont fragment flag */
        #define IP_MF 0x2000            /* more fragments flag */
        #define IP_OFFMASK 0x1fff       /* mask for fragmenting bits */
        u_char  ip_ttl;                 /* time to live */
        u_char  ip_p;                   /* protocol */
        u_short ip_sum;                 /* checksum */
        struct  in_addr ip_src,ip_dst;  /* source and dest address */
};

/* TCP header */
struct sniff_tcp {
        u_short th_sport;                       /* source port */
        u_short th_dport;                       /* destination port */
        tcp_seq th_seq;                         /* sequence number */
        tcp_seq th_ack;                         /* acknowledgement number */
        #if BYTE_ORDER == LITTLE_ENDIAN
                u_int   th_x2:4,                /* (unused) */
                        th_off:4;               /* data offset */
        #endif
        #if BYTE_ORDER == BIG_ENDIAN
                u_int   th_off:4,               /* data offset */
                        th_x2:4;                /* (unused) */
        #endif
        u_char  th_flags;
        u_short th_win;                         /* window */
        u_short th_sum;                         /* checksum */
        u_short th_urp;                         /* urgent pointer */
};



typedef struct NMAP_TX_results{
	int Resp;// code 0= no 1 = yes
	int DF;// code 0 = no 1 = yes
	short W;// actual value
	int Ack;// This one is coded 0 = other 1= S and 2 = S++
	u_char flags;// actual value
	char Ops[16];// character representation from nmap
}NMAP_TX_results;

// My goal here is to have a simpler structure than Fyodors, something that I can 
// more easily move between operating systems, knowing that I will have to do more 
// string work in the at the OOP layer.

typedef struct NMAP_TSeq_results{
	int Resp;
	int Class;// This is coded for the various constants TD, TR etc
	int less_than_sign_gcd;// if gcd has a less than
	int gcd;// the value
	int less_than_sign_SI;// If SI has a less than sign
	int SI;// the value
}NMAP_TSeq_results;

typedef struct NMAP_PU_results{
	int Resp;
	int DF;// code 0= no 1 = yes
	int TOS;
	int IPLEN;
	int RIPTL;
	int RID;
	int RIPCK;
	int UCK;
	int ULEN;
	int DAT;
}NMAP_PU_results;

typedef struct QUESO{
	int Resp;
	int seq;
	int ack;
	int win;
	u_char flags;
}QUESO;

typedef struct NMAP_results{
	char OSname[100];
        NMAP_TSeq_results TSeq; // the results of the TSeq test using a datastructure defined above
        NMAP_TX_results T1; // this is results of the T1 Test
        NMAP_TX_results T2; // This structure allows me to move a nmap test suite conviently
        NMAP_TX_results T3;
        NMAP_TX_results T4;
        NMAP_TX_results T5;
        NMAP_TX_results T6;
        NMAP_TX_results T7;
	NMAP_PU_results PU;// The results of the PU Test
}NMAP_results;


#define MY_CONSTANTS
#endif
//my debuging setup
#ifndef FINDBUGS

#define STEPS
// to step through the system calls

#define FINDBUGS
#endif

