/***************************************************************************
                          nmap_PU.c  -  description
                             -------------------
    begin                : Thu May 16 14:12:39 CDT 2002
    copyright            : (C) 2002 by Fred Trotter
    email                : ftrotter@verisign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "nmap_PU.h"



char *nmap_PU(u_long src_ip,
	      u_long dst_ip,
	      u_short src_prt,
	      u_short dst_prt)
{
    int c;
    libnet_t *l;
    libnet_ptag_t ip;
    libnet_ptag_t udp =0;// without this set to zero there is much pain
    u_short payload_s;
    char errbuf[LIBNET_ERRBUF_SIZE];
    char *to_return;
    u_short ip_id;


    char payload_space[300]; 
    char *payload = payload_space ;
    static unsigned char patternbyte = 0; // this variable needs to be very exactly what it is...
    int datalen = 300;

    

#ifdef STEPS
	printf("NMAP_PU\t I have declared my variables \n");
#endif
      

srand(time(NULL));
if (!patternbyte) patternbyte = rand();
memset(payload, patternbyte, datalen);

#ifdef STEPS
	printf("NMAP_PU\t I have created the 300 bytes of random payload needed for this test \n");
#endif

	
    l = libnet_init(
            LIBNET_RAW4,                            /* injection type */
            NULL,                                   /* network interface */
            errbuf);                                /* errbuf */
 
    if (l == NULL)
    {
        fprintf(stderr, "libnet_init() failed: %s", errbuf);
        exit(EXIT_FAILURE);
    }

    payload_s = 300;


#ifdef STEPS
	printf("NMAP_PU\t I have inited my libnet!!! \n");
#endif

ip_id = rand(); 

if(dst_prt == 0)
{
	dst_prt= rand();
}


        udp = libnet_build_udp(
            src_prt,                                /* source port */
            dst_prt,                            /* destination port */
            LIBNET_UDP_H + payload_s, //should be payload_s              /* packet length */
            0,                                      /* checksum */
            payload,                                /* payload */
            payload_s,                              /* payload size */
            l,                                      /* libnet handle */
            udp);                                   /* libnet id */
        if (udp == -1)
        {
            fprintf(stderr, "Can't build UDP header: %s\n", libnet_geterror(l));
            exit(1); 
        }

    
#ifdef STEPS
	printf("NMAP_PU\t I have built my udp header \n");
#endif

	
    
    ip = libnet_build_ipv4(
        LIBNET_IPV4_H + LIBNET_UDP_H + payload_s,   /* length */
        0,                                          /* TOS */
        ip_id,                                        /* IP ID */
        0,                                          /* IP Frag */
        64,                                         /* TTL */
        IPPROTO_UDP,                                /* protocol */
        0,                                          /* checksum */
        src_ip,                                     /* source IP */
        dst_ip,                                     /* destination IP */
        NULL,                                       /* payload */
        0,                                          /* payload size */
        l,                                          /* libnet handle */
        0);
    if (ip == -1)
    {
        fprintf(stderr, "Can't build IP header: %s\n", libnet_geterror(l));
        exit(1);
    }

#ifdef STEPS
	printf("NMAP_PU\t I have built my IP header \n");
#endif

	c = libnet_write(l); 
            if (c == -1)
            {
                fprintf(stderr, "write error: %s\n", libnet_geterror(l));
		exit(1);
	    }

#ifdef STEPS
	printf("NMAP_PU\t I have written the test to wire \n");
#endif

    libnet_destroy(l);
    return to_return;
}




