/***************************************************************************
                          queso_T3.c  -  description
                             -------------------
    begin                : Thu May 16 14:12:39 CDT 2002
    copyright            : (C) 2002 by Fred Trotter
    email                : ftrotter@verisign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "queso_T3.h"



char *queso_T3(u_long src_ip,
	      u_long dst_ip,
	      u_short src_prt,
	      u_short dst_prt,
	      u_int seq)
{
    int c;
    libnet_t *l;
    libnet_ptag_t tcp;
    char *payload;
    u_short payload_s;
    char errbuf[LIBNET_ERRBUF_SIZE];
    char *to_return;

   if(seq == 0)
   {
	// then the sequence number was not set by the calling program, so I will do it like queso does
	     
    srand (time (NULL) & 0x0000ffff);
	seq=rand();
    }

    
#ifdef STEPS
	printf("QUESO_T1\t I have declared my variables \n");
#endif
    
    l = libnet_init(
            LIBNET_RAW4,                            /* injection type */
            NULL,                                   /* network interface */
            errbuf);                                /* errbuf */
 
    if (l == NULL)
    {
        fprintf(stderr, "libnet_init() failed: %s", errbuf);
        exit(EXIT_FAILURE);
    }

    payload = NULL;
    payload_s = 0;


#ifdef STEPS
	printf("QUESO_T1\t I have inited my libnet!!! \n");
#endif

    


		
    tcp  = 0;



    tcp = libnet_build_tcp(
        src_prt,                                    /* source port */
        dst_prt,                                    /* destination port */
        seq,                                 /* sequence number */
        0,                                 /* acknowledgement num always zero in nmap */
        TH_FIN,                                /* control flags */
        0x1234,                                      /* window size */
        0,                                          /* checksum */
        0,                                          /* urgent pointer */
        LIBNET_TCP_H,              /* TCP packet size */
        payload,                                    /* payload */
        payload_s,                                  /* payload size */
        l,                                          /* libnet handle */
        0);                                         /* libnet id */
    if (tcp == -1)
    {
        fprintf(stderr, "Can't build TCP header: %s\n", libnet_geterror(l));
        exit(1);
    }

    
#ifdef STEPS
	printf("QUESO_T1\t I have built my tcp header \n");
#endif

    
    tcp = libnet_build_ipv4(
        40,                                         /* length */
        0,                                          /* TOS */
        31337 + src_prt,                     /* IP ID */
        0,                                          /* IP Frag */
        255,                                         /* TTL */
        IPPROTO_TCP,                                /* protocol */
        0,                                          /* checksum */
        src_ip,                                     /* source IP */
        dst_ip,                                     /* destination IP */
        NULL,                                       /* payload */
        0,                                          /* payload size */
        l,                                          /* libnet handle */
        0);
    if (tcp == -1)
    {
        fprintf(stderr, "Can't build IP header: %s\n", libnet_geterror(l));
        exit(1);
    }

#ifdef STEPS
	printf("QUESO_T1\t I have built my IP header \n");
#endif

	c = libnet_write(l); 
            if (c == -1)
            {
                fprintf(stderr, "write error: %s\n", libnet_geterror(l));
		exit(1);
	    }

#ifdef STEPS
	printf("QUESO_T1\t I have written the test to wire \n");
#endif

    libnet_destroy(l);
    return to_return;
}




