/***************************************************************************
                          queso_listen.c  -  description
                             -------------------
    begin                : Thu May 16 14:12:39 CDT 2002
    copyright            : (C) 2002 by Fred Trotter
    email                : ftrotter@verisign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "queso_listen.h"



/* callback function that is passed to pcap_loop(..) and called each time 
 * a packet is recieved                                                    */

char *queso_listen(u_long src_ip_i_used,
	      u_long dst_ip_i_used,
	      u_short prt_i_used,
	      u_int seq)
{
    
	
    char *dev; 
    char errbuf[PCAP_ERRBUF_SIZE];
    pcap_t* descr;
    const u_char *packet;
    struct pcap_pkthdr hdr;     /* pcap.h */
    char *to_return;
//    struct bpf_program fp;      /* hold compiled program     */
    bpf_u_int32 maskp;          /* subnet mask               */
    bpf_u_int32 netp;           /* ip                        */
//    char *ip_char;              /* my targets ip in text */
 //   char filter[40] = "src ";		/* my pcap filter description */
 
        const struct sniff_ethernet *ethernet;  /* The ethernet header */
        const struct sniff_ip *ip;              /* The IP header */
        const struct sniff_tcp *tcp;            /* The TCP header */
        const char *payload;                    /* Packet payload */
        /* And define the size of the structures we're using */
        int size_ethernet = sizeof(struct sniff_ethernet);
        int size_ip = sizeof(struct sniff_ip);
        int size_tcp = sizeof(struct sniff_tcp);

     // ganked from fingerprinttcp function of osscan.c	
     char *q;  
     int length;
     int opcode;
     unsigned short tmpshort;
     int mss=265;
     // I will use these three variables in my options fingerprinting code...
//filter needs to be big enough to hold the string "src 111.111.111.111 and port 65555" which is 35
    // i figure 40 for good measure 
    
    /* grab a device to peak into... */

#ifdef STEPS
	printf ("LISTEN \t I have declared my variables \n");
#endif
	
    dev = pcap_lookupdev(errbuf);

    if(dev == NULL)
    {
        printf("%s\n",errbuf);
        exit(1);
    }

#ifdef STEPS
	printf("LISTEN \t I have gotten a interface DEV: %s\n",dev);    
#endif

        /* ask pcap for the network address and mask of the device */
    pcap_lookupnet(dev,&netp,&maskp,errbuf);

#ifdef STEPS
       printf("LISTEN \t I have the net adder and mask of the device\n");
#endif   
    
    /* open the device for sniffing.

       pcap_t *pcap_open_live(char *device,int snaplen, int prmisc,int to_ms,
       char *ebuf)

       snaplen - maximum size of packets to capture in bytes
       promisc - set card in promiscuous mode?
       to_ms   - time to wait for packets in miliseconds before read
       times out
       errbuf  - if something happens, place error string here
     */

    /* get packet capture descriptor from capture.  Note if you change
       "prmisc" param to anything other than zero, you will get all
       packets your device sees, whether they are intendeed for you or 
       not!! Be sure you know the rules of the network you are running
       on before you set your card in promiscuous mode or you could get
       yourself in serious doo doo!!! (also need to be root to run in
       promisuous mode)                                               */
    descr = pcap_open_live(dev,BUFSIZ,0,-1,errbuf);
    if(descr == NULL)
    {
        printf("pcap_open_live(): %s\n",errbuf);
        exit(1);
    }

#ifdef STEPS 
    printf("LISTEN\t I have a pcap descriptor \n");
#endif
// first lets get my long ip addresss into a char format
 
  
//ip_char =  libnet_addr2name4(dst_ip_i_used ,LIBNET_RESOLVE);
//strcat(filter,ip_char);
//strcat(filter," and port ");
//strcat(filter, prt_i_used);
    
 // Lets try and compile the program.. non-optimized //
//    if(pcap_compile(descr,&fp,"src 64.39.31.181 and port 10000" ,0,netp) == -1)
 //   { fprintf(stderr,"Error calling pcap_compile\n"); exit(1); }
#ifdef STEPS
    printf("LISTEN\t my filter compiled \n");
#endif

    
    /* set the compiled program as the filter */
//    if(pcap_setfilter(descr,&fp) == -1)
//    { fprintf(stderr,"Error setting filter\n"); exit(1); }
#ifdef STEPS
    printf("LISTEN\t and is now filtering my descriptor\n");
#endif

    
    /* grab a packet from descr (yay!)                    */
    /* const u_char *pcap_next(pcap_t *p,struct pcap_pkthdr *h) */
    /* so just pass in the descriptor we got from         */
    /* our call to pcap_open_live and an allocated        */ 
    /* struct pcap_pkthdr                                 */

// I need to get to this point before I run the send system....
// may a 
    // prepare to listen
    // shout
    // listen

    packet = pcap_next(descr,&hdr);
    if(packet == NULL)
    {/* dinna work *sob* */
        printf("Didn't grab packet\n");
        exit(1);
    }

#ifdef STEPS
    printf("LISTEN\t so I grabbed a packet !! \n");
#endif

    /*  
        struct pcap_pkthdr {
        struct timeval ts;    time stamp 
        bpf_u_int32 caplen;   length of portion present 
        bpf_u_int32;          lebgth this packet (off wire) 
        }
     */
#ifdef STEPS
    printf("LISTEN\t Grabbed packet of length %d\n",hdr.len);
    printf("LISTEN\t Recieved it ..... %s\n",ctime((const time_t*)&hdr.ts.tv_sec)); 
    printf("LISTEN\t Ethernet address length is %d\n",ETHER_HDR_LEN);
#endif
 /* Define pointers for packet's attributes */
        /* -- Define our packet's attributes -- */
        ethernet = (struct sniff_ethernet*)(packet);
        ip = (struct sniff_ip*)(packet + size_ethernet);
        tcp = (struct sniff_tcp*)(packet + size_ethernet + size_ip);
        payload = (u_char *)(packet + size_ethernet + size_ip + size_tcp);

#ifdef STEPS	
	printf("LISTEN\t From:    %s:%d\n", inet_ntoa(ip->ip_src), ntohs(tcp->th_sport));
	printf("LISTEN\t To:      %s:%d\n", inet_ntoa(ip->ip_dst), ntohs(tcp->th_dport));

// the first test is to see if the dont fragment bit is set, thats pretty easy.	
if(ntohs(ip->ip_off) & 0x4000)
{
	printf("LISTEN\t DF=yes\n");
}	
else
{
	printf("LISTEN\t DF=no\n");
}
// Then we look at the window size
        printf("LISTEN\t W=%d\n", ntohs(tcp->th_win));

// Then we calculate the ACK codes...

if (ntohl(tcp->th_ack)== seq + 1)
{
	printf("LISTEN\t ACK=S++\n");
}
else if (ntohl(tcp->th_ack) == seq)
{
	printf("LISTEN\t ACK=S\n");
}
else
{
	printf("LISTEN\t ACK=O\n");	
}	

// Now we look at the tcp flags...

if (tcp->th_flags & TH_BOGUS) printf("LISTEN\t Flags=B\n");
if (tcp->th_flags & TH_URG) printf("LISTEN\t Flags=U\n");
if (tcp->th_flags & TH_ACK) printf("LISTEN\t Flags=A\n");
if (tcp->th_flags & TH_PUSH) printf("LISTEN\t Flags=P\n");
if (tcp->th_flags & TH_RST) printf("LISTEN\t Flags=R\n");
if (tcp->th_flags & TH_SYN) printf("LISTEN\t Flags=S\n");
if (tcp->th_flags & TH_FIN) printf("LISTEN\t Flags=F\n");

// Now the hard one
// the dreaded options


#endif
//  p = AVs[5].value;
//  Partly swiped from /usr/src/linux/net/ipv4/tcp_input.c in Linux kernel 
  length = (tcp->th_off * 4) - sizeof(struct tcphdr);
  q = ((char *)tcp) + sizeof(struct tcphdr);

  while(length > 0){// &&
//	((p - AVs[5].value) < (int) (sizeof(AVs[5].value) - 3))) {
   opcode=*q++;
  length--;
   if (!opcode) {
      printf("LISTEN:\t  OP= 'L'\n"); // End of List 
      break;
    } else if (opcode == 1) {
      printf("LISTEN:\t OP = 'N'\n");//    *p++ = 'N'; // No Op 
    } else if (opcode == 2) {
      printf("LISTEN:\t OP = 'M'\n");//*p++ = 'M'; // MSS 
      q++;
     memcpy(&tmpshort, q, 2);
      if(ntohs(tmpshort) == mss)
	printf("LISTEN:\t OP = 'E'\n");//*p++ = 'E'; // Echoed 
      q += 2;
        length -= 3;
    } else if (opcode == 3) { // Window Scale 
       printf("LISTEN:\t OP = 'W'\n");//*p++ = 'W';
      q += 2;
      length -= 2;
    } else if (opcode == 8) { // Timestamp 
      printf("LISTEN:\t OP = 'T'\n");//*p++ = 'T';
      q += 9;
      length -= 9;
    }
  }






	
	return to_return;

	

}




