/***************************************************************************
                          x_mr.c  -  description
                             -------------------
    begin                : Thu May 16 14:12:39 CDT 2002
    copyright            : (C) 2002 by Fred Trotter
    email                : ftrotter@verisign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "x_mr.h"



char *x_mr(u_long src_ip,
	      u_long dst_ip,
	      u_short seq)
{
    int c;
  //  struct timeval s;
    libnet_t *l;
    libnet_ptag_t icmp;
    char *payload;
    u_short payload_s;
    char errbuf[LIBNET_ERRBUF_SIZE];
    char *to_return;

#ifdef STEPS
	printf("X_IR\t I have declared my variables \n");
#endif
    
    l = libnet_init(
            LIBNET_RAW4,                            /* injection type */
            NULL,                                   /* network interface */
            errbuf);                                /* errbuf */
 
    if (l == NULL)
    {
        fprintf(stderr, "libnet_init() failed: %s", errbuf);
        exit(EXIT_FAILURE);
    }

    payload = NULL;
    payload_s = 20;


#ifdef STEPS
	printf("X_IR\t I have inited my libnet!!! \n");
#endif

    if (seq==0)
    {// if there was no sequence number set then lets build one...
	 srand(time(NULL));
	seq=(u_short)rand();
    }


    
       icmp = libnet_build_icmpv4_echo(
        17,                       /* type */
        0,                       /* code */
        0,                      /* checksum */
	0,			/*id*/
            seq,           /* o sequence */
            NULL,                /* payload */
            payload_s,         /* payload size */
            l,                 /* libnet handle */
            0);
    if (icmp == -1)
    {
        fprintf(stderr, "Can't build ICMP header: %s\n", libnet_geterror(l));
        exit(1);
    }











/*
    tcp = libnet_build_tcp(
        src_prt,                                    // source port 
        dst_prt,                                    // destination port 
        seq,                                 // sequence number 
        0,                                 // acknowledgement num always zero in nmap 
        TH_SYN|TH_BOGUS,                                // control flags 
        2048,                                      // window size 
        0,                                          // checksum 
        0,                                          // urgent pointer 
        LIBNET_TCP_H + 20 + payload_s,              // TCP packet size 
        payload,                                    // payload 
        payload_s,                                  // payload size 
        l,                                          // libnet handle 
        0);                                         // libnet id 
    if (tcp == -1)
    {
        fprintf(stderr, "Can't build TCP header: %s\n", libnet_geterror(l));
        exit(1);
    }

  */  
#ifdef STEPS
	printf("X_IR\t I have built my icmp header \n");
#endif




	
    
    icmp = libnet_build_ipv4(
        LIBNET_IPV4_H + LIBNET_UDP_H + payload_s,   /* length */
        0,                                          /* TOS */
        242,                                        /* IP ID */
        0,                                          /* IP Frag */
        64,                                         /* TTL */
        IPPROTO_ICMP,                                /* protocol */
        0,                                          /* checksum */
        src_ip,                                     /* source IP */
        dst_ip,                                     /* destination IP */
        NULL,                                       /* payload */
        0,                                          /* payload size */
        l,                                          /* libnet handle */
        0);
    if (icmp == -1)
    {
        fprintf(stderr, "Can't build IP header: %s\n", libnet_geterror(l));
        exit(1);
    }

#ifdef STEPS
	printf("X_IR\t I have built my IP header \n");
#endif

	c = libnet_write(l); 
            if (c == -1)
            {
                fprintf(stderr, "write error: %s\n", libnet_geterror(l));
		exit(1);
	    }

#ifdef STEPS
	printf("X_IR\t I have written the test to wire \n");
#endif

    libnet_destroy(l);
    return to_return;
}




